AliasUnit_Composite Class Reference

A subunit in a CompositeUnit. More...

`#include <Unit.h>`

Inheritance diagram for AliasUnit_Composite:

## Public Member Functions

| AliasUnit_Composite (Unit *alias, int exp=1, Prefix *prefix_=NULL)
| AliasUnit_Composite (const AliasUnit_Composite *unit)
virtual ExpressionItem * | copy () const
virtual void | set (const ExpressionItem *item)
virtual string | print (bool plural_, bool short_, bool use_unicode=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual Prefix * | prefix () const
virtual int | prefixExponent () const
virtual void | set (Unit *u, int exp=1, Prefix *prefix_=NULL)
virtual MathStructure & | convertToFirstBaseUnit (MathStructure &mvalue, MathStructure &mexp) const
virtual MathStructure & | convertFromFirstBaseUnit (MathStructure &mvalue, MathStructure &mexp) const
Public Member Functions inherited from AliasUnit
| AliasUnit (string cat_, string name_, string plural_, string singular_, string title_, Unit *alias, string relation="1", int exp=1, string inverse="", bool is_local=true, bool is_builtin=false, bool is_active=true)
| AliasUnit (const AliasUnit *unit)
virtual Unit * | baseUnit () const
virtual Unit * | firstBaseUnit () const
virtual void | setBaseUnit (Unit *alias)
virtual string | expression () const
virtual string | inverseExpression () const
virtual void | setExpression (string relation)
virtual void | setInverseExpression (string inverse)
virtual MathStructure & | convertToBaseUnit (MathStructure &mvalue, MathStructure &mexp) const
virtual MathStructure & | convertFromBaseUnit (MathStructure &mvalue, MathStructure &mexp) const
virtual MathStructure & | convertToBaseUnit (MathStructure &mvalue) const
virtual MathStructure & | convertFromBaseUnit (MathStructure &mvalue) const
virtual MathStructure | convertToBaseUnit () const
virtual MathStructure | convertFromBaseUnit () const
virtual int | baseExponent (int exp=1) const
virtual void | setExponent (int exp)
virtual int | firstBaseExponent () const
virtual int | subtype () const
virtual bool | isChildOf (Unit *u) const
virtual bool | isParentOf (Unit *u) const
virtual bool | hasComplexExpression () const
virtual bool | hasComplexRelationTo (Unit *u) const
Public Member Functions inherited from Unit
| Unit (string cat_, string name_, string plural_="", string singular_="", string title_="", bool is_local=true, bool is_builtin=false, bool is_active=true)
| Unit (const Unit *unit)
bool | isSIUnit () const
void | setAsSIUnit ()
void | setSystem (string s_system)
const string & | system () const
bool | useWithPrefixesByDefault () const
void | setUseWithPrefixesByDefault (bool use_with_prefixes)
bool | isCurrency () const
virtual const string & | plural (bool return_singular_if_no_plural=true, bool use_unicode=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const string & | singular (bool return_abbreviation_if_no_singular=true, bool use_unicode=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const string & | abbreviation (bool return_singular_if_no_abbreviation=true, bool use_unicode=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual bool | isUsedByOtherUnits () const
virtual int | type () const
bool | convert (Unit *u, MathStructure &mvalue, MathStructure &exp) const
bool | convert (Unit *u, MathStructure &mvalue) const
MathStructure | convert (Unit *u, bool *converted=NULL) const
Public Member Functions inherited from ExpressionItem
| ExpressionItem (string cat_, string name_, string title_="", string descr_="", bool is_local=true, bool is_builtin=false, bool is_active=true)
virtual bool | destroy ()
bool | isRegistered () const
void | setRegistered (bool is_registered)
| For internal use.
virtual const string & | name (bool use_unicode=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const string & | referenceName () const
virtual const ExpressionName & | preferredName (bool abbreviation=false, bool use_unicode=false, bool plural=false, bool reference=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const ExpressionName & | preferredInputName (bool abbreviation=false, bool use_unicode=false, bool plural=false, bool reference=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const ExpressionName & | preferredDisplayName (bool abbreviation=false, bool use_unicode=false, bool plural=false, bool reference=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const ExpressionName & | getName (size_t index) const
virtual void | setName (const ExpressionName &ename, size_t index=1, bool force=true)
virtual void | setName (string sname, size_t index, bool force=true)
virtual void | addName (const ExpressionName &ename, size_t index=0, bool force=true)
virtual void | addName (string sname, size_t index=0, bool force=true)
virtual size_t | countNames () const
virtual void | clearNames ()
virtual void | clearNonReferenceNames ()
virtual void | removeName (size_t index)
virtual size_t | hasName (const string &sname, bool case_sensitive=true) const
virtual size_t | hasNameCaseSensitive (const string &sname) const
virtual const ExpressionName & | findName (int abbreviation=-1, int use_unicode=-1, int plural=-1, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const string & | title (bool return_name_if_no_title=true, bool use_unicode=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual void | setTitle (string title_)
virtual const string & | description () const
virtual void | setDescription (string descr_)
virtual const string & | category () const
virtual void | setCategory (string cat_)
virtual bool | hasChanged () const
virtual void | setChanged (bool has_changed)
virtual bool | isLocal () const
virtual bool | setLocal (bool is_local=true, int will_be_active=-1)
virtual bool | isBuiltin () const
virtual bool | isApproximate () const
virtual void | setApproximate (bool is_approx=true)
virtual int | precision () const
virtual void | setPrecision (int prec)
virtual bool | isActive () const
virtual void | setActive (bool is_active)
virtual bool | isHidden () const
virtual void | setHidden (bool is_hidden)
virtual int | refcount () const
virtual void | ref ()
virtual void | unref ()
virtual void | ref (ExpressionItem *o)
virtual void | unref (ExpressionItem *o)
virtual ExpressionItem * | getReferencer (size_t index=1) const
virtual bool | changeReference (ExpressionItem *o_from, ExpressionItem *o_to)

## Protected Attributes

Prefix * | prefixv
Protected Attributes inherited from AliasUnit
string | svalue
string | sinverse
int | i_exp
Unit * | o_unit
Protected Attributes inherited from Unit
string | ssystem
bool | b_si
bool | b_use_with_prefixes
Protected Attributes inherited from ExpressionItem
string | scat
string | stitle
string | sdescr
bool | b_local
bool | b_changed
bool | b_builtin
bool | b_approx
bool | b_active
bool | b_registered
bool | b_hidden
bool | b_destroyed
int | i_ref
int | i_precision
vector< ExpressionItem * > | v_refs
vector< ExpressionName > | names

## Detailed Description

A subunit in a CompositeUnit.

Should normally not be used directly.

## Member Function Documentation

virtual string AliasUnit_Composite::print | ( | bool | plural_,
|  | bool | short_,
|  | bool | use_unicode = `false`,
|  | bool(*)(const char *, void *) | can_display_unicode_string_function = `NULL`,
|  | void * | can_display_unicode_string_arg = `NULL`
| ) |  | const

virtual

Returns a display string representing the unit in an expression.

Equivalent to preferredName() for Unit and AliasUnit, but closer to MathStructure::print() for CompositeUnit (prints out base expression).

Reimplemented from Unit.

The documentation for this class was generated from the following file:

- libqalculate/Unit.h